import numpy as np
from sklearn.svm import LinearSVC
from sklearn.model_selection import train_test_split



D = np.loadtxt( "datos.txt" )
print( D.shape )

X = D[:,0:2]
y = D[:,2]

X_entrena, X_prueba, y_entrena, y_prueba = train_test_split( X, y, random_state=10)

clasificador = LinearSVC( dual="auto" )

clasificador.fit( X_entrena, y_entrena )

precision = clasificador.score( X_prueba, y_prueba )
print( precision )

print( clasificador.coef_ ) 
print( clasificador.intercept_ ) 
print( clasificador.classes_ ) 
